QGIS Application - Bug report #17843
Can't add QGIS raster calculator in the processing modeller
2018-01-12 08:55 AM - Alister Hood

Status: Closed

Priority: Normal

Assignee: Mathieu Pellerin - nIRV

Category: Processing/QGIS

Affected QGIS version:master Regression?: No

Operating System: Windows Easy fix?: No

Pull Request or Patch supplied: Resolution: fixed/implemented
Crashes QGIS or corrupls data: Copied to github as #: 25738
Description

When | try to add the QGIS raster calculator in the processing modeller there is a "Python error".
BTW the reason | wanted to try to use it when there are other raster calculators available is that | was hoping it supported referring to
model values the way the Modeler-only "Calculator" tool does i.e. a->VARIABLE_NAME. But it seems the Modeler-only tools have been

removed in QGIS3!

fa2aff18e5

Associated revisions

Revision eb7a187a - 2018-01-15 07:13 PM - Alexander Bruy

[processing] add missed imports (fix #17843)

History

#1 - 2018-01-15 07:14 PM - Alexander Bruy
- % Done changed from 0 to 100
- Status changed from Open to Closed

Applied in changeset commit:qgis|eb7a187a88f1994ccdd6d3f0d020cb925be54229.

#2 - 2018-01-16 10:37 PM - Alister Hood

The dialog opens now, but there is an error if | try to use it:

An error has occurred while executing Python code:

AttributeError: 'LayersListWidgetWrapper' object has no attribute '_getOptions'
Traceback (most recent call last):
File "C:/OSGEO4~1/apps/qgis-dev/./python/plugins\processing\modeler\ModelerParametersDialog.py", line 357, in okPressed
alg = self.createAlgorithm()
File "C:/OSGEO4~1/apps/qgis-dev/./python/plugins\processing\modeler\ModelerParametersDialog.py", line 308, in createAlgorithm
val = self.wrappers[param.name()].value()
File "C:/OSGEO4~1/apps/qgis-dev/./python/plugins\processing\algs\qgis\ui\RasterCalculatorWidgets.py", line 249, in value
options = self._getOptions()
AttributeError: 'LayersListWidgetWrapper' object has no attribute '_getOptions'
Python version: 3.6.0 (v3.6.0:41df79263a11, Dec 23 2016, 08:06:12) [MSC v.1900 64 bit (AMD64)]
QGIS version: 2.99.0-Master Master, 05¢7132518

Python Path:

C:/OSGEO4~1/apps/qgis-dev/./python/plugins\processing
C:/OSGEO4~1/apps/qgis-dev/./python
C:/Users/alistair/AppData/Roaming/QGIS/QGIS3\profiles\default/python
C:/Users/alistair/AppData/Roaming/QGIS/QGIS3\profiles\default/python/plugins
C:/OSGEO4~1/apps/qgis-dev/./python/plugins
C:\0OSGeo4W64\bin\python36.zip

C:\OSGEO4~1\apps\Python36\DLLs

C:\OSGEO4~1\apps\Python36\lib

C:\OSGe04W64\bin

C:\OSGEO4~1\apps\Python36
C:\OSGEO4~1\apps\Python36\lib\site-packages
C:/Users/alistair/AppData/Roaming/QGIS/QGIS3\profiles\default/python

Should | open another ticket?
05c7132518

#3 - 2018-01-21 11:20 PM - Alister Hood
- Status changed from Closed to Reopened

I am happy to file a new ticket, but | am reopening for now: as described in the previous comment, although the dialog now opens, it errors when you click

'OK', so you still can't actually add it to a model.

| have also noticed that it doesn't list all of the available raster layers. i.e. it lists all layers that are explicit model inputs, but if another algorithm which

generates a raster layer is used more than once in the model, it only lists the output from one of those uses. This is unlike other algorithms, where all raster

layers are available.

Note that fixing this second issue still leaves a wider problem with the model builder: if you have a model where the same algorithm is used more than

once, there is no way to tell the difference between the outputs of each, for use in other algorithms in the model. You might expect to be able to work

around this by naming the outputs (i.e. as "final results"), but the names of final results aren't added to the list of input layers.

#4 - 2018-01-22 07:05 AM - Alister Hood

Note that if this is fixed #17430 can also be closed.

I have also noticed that it doesn't list all of the available raster layers...

| was wondering if this is related to the fact that when you try to use the output from another algorithm, it shows as this, which looks wrong:
"<qgis._core.QgsProcessingModelChildParameterSource object at 0x000001B39085B3A8>@1"

#5 - 2018-02-13 10:50 AM - Mathieu Pellerin - nIRV
- Status changed from Reopened to Closed
- Resolution set to fixed/implemented

2025-12-15 2/4



- Assignee changed from Victor Olaya to Mathieu Pellerin - nIRV

Alister, I'm pretty sure the raster calculator now works well within a model. Let me know if it's not the case.

#6 - 2018-02-20 07:50 AM - Alister Hood
- Status changed from Closed to Reopened

I'm still getting this on Windows (latest osgeo4w64 nightly) when | try to add it to the model:
An error has occurred while executing Python code:
AttributeError: type object 'QgsProcessing’ has no attribute 'FlagOptional'
Traceback (most recent call last):
File "C:/OSGEO4~1/apps/qgis-dev/./python/plugins\processing\modeler\ModelerParametersDialog.py", line 359, in okPressed
alg = self.createAlgorithm()
File "C:/OSGEO4~1/apps/qgis-dev/./python/plugins\processing\modeler\ModelerParametersDialog.py", line 310, in createAlgorithm
val = self.wrappers[param.name()].value()
File "C:/OSGEO4~1/apps/qgis-dev/./python/plugins\processing\gui\wrappers.py", line 696, in value
if len(values) == 0 and not self.param.flags() & QgsProcessing.FlagOptional:

AttributeError: type object 'QgsProcessing’ has no attribute 'FlagOptional'

Python version: 3.6.0 (v3.6.0:41df79263a11, Dec 23 2016, 08:06:12) [MSC v.1900 64 bit (AMD64)]
QGIS version: 2.99.0-Master Master, 2¢53630747

#7 - 2018-02-20 08:23 AM - Alister Hood

Alister Hood wrote:

I'm still getting this on Windows (latest osgeo4w64 nightly) when | try to add it to the model:

FWIW | can't test on linux as the only master build | have is in an ubuntu install on WSL, and the processing modeller does not work there (the panes on the

left are rendered with all their widgets on top of each other)... | presume it does work on normal linux installs?

#8 - 2018-02-21 06:01 AM - Mathieu Pellerin - nIRV

- Status changed from Reopened to Closed

Alister, fixed the 'QgsProcessing' has no attribute 'FlagOptional'

error, thanks for the report.

#9 - 2018-11-13 09:26 AM - Alister Hood

BTW the reason | wanted to try to use it when there are other raster calculators available is that | was hoping it supported referring to model values
the way the Modeler-only "Calculator” tool does i.e. a->VARIABLE_NAME. But it seems the Modeler-only tools have been removed in QGIS3!
The simple workaround for what | wanted to achieve (FWIW | need it more often than not for my processing use cases) is to feed the value from user input

to the "create constant raster algorithm", and use the output of that in the raster calculator. Creating a raster just for that seems rather inefficient though.
